package com.community.huiju.service.impl;
import com.alibaba.fastjson.JSONObject;
import com.community.commom.ailiyun.AESDecode;
import com.community.commom.constant.Constant;
import com.community.commom.mode.ResponseBean;
import com.community.huiju.common.hk.HKOpenApi;
import com.community.huiju.dao.TaFaceMapper;
import com.community.huiju.dao.TaSysRoleMapper;
import com.community.huiju.dao.TaUserMapper;
import com.community.huiju.model.TaFace;
import com.community.huiju.model.TaSysRole;
import com.community.huiju.model.TaUser;
import com.community.huiju.service.FaceServiceI;
import com.community.huiju.service.ImageServiceI;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Date;

@Service("faceServicel")
@Transactional
public class FaceServicelimpl implements FaceServiceI {


    @Autowired
    private TaFaceMapper taFaceMapper;

    @Autowired
    private TaUserMapper taUserMapper;

    @Autowired
    private TaSysRoleMapper taSysRoleMapper;

    @Autowired
    private ImageServiceI imageServiceI;

    @Override
    public ResponseBean addFace(Integer userid,MultipartFile uploadFile) {
        String faceImg = null;
        try {
            faceImg=imageServiceI.getImageUrl(uploadFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
        TaUser user=taUserMapper.selectByPrimaryKey(userid);
        ResponseBean response = new ResponseBean();
        TaFace taFace = new TaFace();
        taFace.setCommunityId(user.getCommunityId());
        taFace.setTaUserId(userid);
        taFace.setCreateUser(userid);
        taFace.setUpdateUser(userid);
        taFace.setCreateDate(new Date());
        taFace.setUpdateDate(new Date());
        //已登陆，身份未知，状态未知

        //判断身份是否为业主且状态为已停用
        TaSysRole sysRole = taSysRoleMapper.findRoleByUserId(userid);
        TaUser taUser = taUserMapper.selectByPrimaryKey(userid);
        if (Constant.INVALID.equals(taUser.getStatus())
                && Constant.OWNER.equals(sysRole.getRoleName())) {

            response.addError("9996", "您的身份已停用，请联系物业");
            return response;
        }

        //身份为家属租客，状态为已停用
        if (Constant.INVALID.equals(taUser.getStatus())
                && (Constant.RELATION.equals(sysRole.getRoleName())) || Constant.TENANT.equals(sysRole.getRoleName())) {

            response.addError("9996", "您的身份已停用，请联系物业");
            return response;
        }

        //查询当前用户是否有人脸记录
        TaFace User = taFaceMapper.getByUserId(userid);
        if (null == User) {
            boolean isA=true;
            if (Constant.OWNER.equals(sysRole.getRoleName()) && "1".equals(taUser.getVerifyStatus())) {
                ResponseBean responseBean = new ResponseBean();
                Object resps=checKout(faceImg,taFace,isA,uploadFile,userid);
                if (null!=resps && "true".equals(resps)) {
                    responseBean.addSuccess("图片录入成功");
                }else {
                        responseBean.addError("7771","请录入正确的图片");
                }
                return responseBean;
            }
            //家属或者租客，已认证
            if (Constant.RELATION.equals(sysRole.getRoleName()) || Constant.TENANT.equals(sysRole.getDescription()) && "1".equals(taUser.getVerifyStatus())) {
                ResponseBean responseBeans = new ResponseBean();
                boolean resps= (boolean) checKout(faceImg,taFace,isA,uploadFile,userid);
                if (resps == true) {
                    responseBeans.addSuccess("图片录入成功");
                }else {
                            responseBeans.addError("7771","请录入正确的图片");
                }
                return responseBeans;
            }
        }
        return response;
    }

    @Override
    public ResponseBean upDateFace(Integer userId,MultipartFile uploadFile) {
        boolean isA=false;
        String faceImg = null;
        try {
            faceImg=imageServiceI.getImageUrl(uploadFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
        TaUser user=taUserMapper.selectByPrimaryKey(userId);
        ResponseBean responseBean = new ResponseBean();
        TaFace taFace = new TaFace();
        taFace.setCommunityId(user.getCommunityId());
        taFace.setTaUserId(userId);
        taFace.setUpdateUser(userId);
        taFace.setUpdateDate(new Date());
        boolean resps= (boolean) checKout(faceImg,taFace,isA,uploadFile,userId);
        if (resps == true) {
            responseBean.addSuccess("图片修改成功");
        }else {
            responseBean.addError("7771","请录入正确的图片");
        }
        return responseBean;
    }
    
    /**
     * 人脸录入验证
     */
    public Object checKout(String faceImg, TaFace taFace, boolean isA,MultipartFile uploadFile,Integer userId) {
        Integer status=1;
        TaUser user=taUserMapper.selectByPrimaryKey(userId);
        if (user!=null){
            return status;
        }
        AESDecode aesd = new AESDecode();
        String body = "{\"type\": \"0\", \"image_url\":\"" + faceImg + "\"}";
        try {
            ResponseBean responseBean = aesd.send(body);
            JSONObject jsonObject = JSONObject.parseObject(responseBean.getMessage());
            Integer type = (Integer) jsonObject.get("errno");
            Integer faceNum= (Integer) jsonObject.get("face_num");

            /*boolean isA为true进行添加，为false进行修改*/
            if (0==type && 1==faceNum && isA) {

                    /*推送海康*/
                String code=HKOpenApi.HKpersonGroupId(uploadFile,user.get,user.getUserName());

                    taFace.setFaceImg(faceImg);
                    taFaceMapper.insertSelective(taFace);
                    return true;
            }else if (0==type && 1==faceNum && isA==false){

                String code=HKOpenApi.HKpersonGroupId( faceImg, userId, personNo, user.getUserName());

                taFace.setFaceImg(faceImg);
                taFaceMapper.updateByPrimaryKeySelective(taFace);
                return true;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }




}
